Subject: Re: [PATCH bpf 2/2] libbpf: remove dependency on barrier.h in xsk.h

From: Yauheni Kaliuta <[email-masked]>
Date: Wed, 04 Sep 2019 15:19:06 +0300

Hi, Magnus!

>>>>> On Wed, 4 Sep 2019 12:25:13 +0200, Magnus Karlsson  wrote:
 > On Wed, Sep 4, 2019 at 8:56 AM Yauheni Kaliuta
 > <[email-masked]> wrote:
 >> 
 >> Hi, Magnus!
 >> 
 >> >>>>> On Wed, 4 Sep 2019 08:39:24 +0200, Magnus Karlsson  wrote:
 >> 
 >> > On Wed, Sep 4, 2019 at 7:32 AM Yauheni Kaliuta
 >> > <[email-masked]> wrote:
 >> >>
 >> >> Hi, Magnus!
 >> >>
 >> >> >>>>> On Tue,  9 Apr 2019 08:44:13 +0200, Magnus Karlsson  wrote:
 >> >>
 >> >> > The use of smp_rmb() and smp_wmb() creates a Linux header dependency
 >> >> > on barrier.h that is uneccessary in most parts. This patch implements
 >> >> > the two small defines that are needed from barrier.h. As a bonus, the
 >> >> > new implementations are faster than the default ones as they default
 >> >> > to sfence and lfence for x86, while we only need a compiler barrier in
 >> >> > our case. Just as it is when the same ring access code is compiled in
 >> >> > the kernel.
 >> >>
 >> >> > Fixes: 1cad07884239 ("libbpf: add support for using AF_XDP sockets")
 >> >> > Signed-off-by: Magnus Karlsson <[email-masked]>
 >> >> > ---
 >> >> >  tools/lib/bpf/xsk.h | 19 +++++++++++++++++--
 >> >> >  1 file changed, 17 insertions(+), 2 deletions(-)
 >> >>
 >> >> > diff --git a/tools/lib/bpf/xsk.h b/tools/lib/bpf/xsk.h
 >> >> > index 3638147..317b44f 100644
 >> >> > --- a/tools/lib/bpf/xsk.h
 >> >> > +++ b/tools/lib/bpf/xsk.h
 >> >> > @@ -39,6 +39,21 @@ DEFINE_XSK_RING(xsk_ring_cons);
 >> >> >  struct xsk_umem;
 >> >> >  struct xsk_socket;
 >> >>
 >> >> > +#if !defined bpf_smp_rmb && !defined bpf_smp_wmb
 >> >> > +# if defined(__i386__) || defined(__x86_64__)
 >> >> > +#  define bpf_smp_rmb() asm volatile("" : : : "memory")
 >> >> > +#  define bpf_smp_wmb() asm volatile("" : : : "memory")
 >> >> > +# elif defined(__aarch64__)
 >> >> > +#  define bpf_smp_rmb() asm volatile("dmb ishld" : : : "memory")
 >> >> > +#  define bpf_smp_wmb() asm volatile("dmb ishst" : : : "memory")
 >> >> > +# elif defined(__arm__)
 >> >> > +#  define bpf_smp_rmb() asm volatile("dmb ish" : : : "memory")
 >> >> > +#  define bpf_smp_wmb() asm volatile("dmb ishst" : : : "memory")
 >> >> > +# else
 >> >> > +#  error Architecture not supported by the XDP socket code in libbpf.
 >> >> > +# endif
 >> >> > +#endif
 >> >> > +
 >> >>
 >> >> What about other architectures then?
 >> 
 >> > AF_XDP has not been tested on anything else, as far as I
 >> > know. But contributions that extend it to more archs are
 >> > very welcome.
 >> 
 >> Well, I'll may be try to fetch something from barrier.h's
 >> (since I cannot consider myself as a specialist in the area),
 >> but at the moment the patch breaks the build on that arches.

 > Do you have a specific architecture in mind and do you have
 > some board/server (of that architecture) you could test AF_XDP
 > on?

I do care about s390 and ppc64 and I can run tests for them.

[...]

-- 
WBR,
Yauheni Kaliuta